/*
 * 	Doku, siehe http://www.mikrocontroller.net/articles/AVR_FAT32
 *  Neuste Version: http://www.mikrocontroller.net/svnbrowser/avr-fat32/
 *	Autor: Daniel R.
 */

#include "mmc_config.h"
#include "uart.h"



//***********************Funktionen**********************************
void uputc(unsigned char c){		//zeichen senden

	loop_until_bit_is_set(UCSRA,UDRE);	// warten bis puffer frei ist
	UDR = c;								// zeichen schreiben
}

void uputx(const unsigned char c)	{
	unsigned char dig = c>>4;
	dig&=0xF;
	dig+='0';
	if(dig>'9')dig+='A'-'0'-10;
	uputc(dig);
	
	dig = c&0xF;
	dig&=0xF;
	dig+='0';
	if(dig>'9')dig+='A'-'0'-10;
	uputc(dig);
}

void uputl(const unsigned long l){
	uputc('0');
	uputc('x');
	uputx((unsigned char)(l>>24));
	uputx((unsigned char)(l>>16));
	uputx((unsigned char)(l>>8));
	uputx((unsigned char)(l));
}



//*******************************************************************
void uputs (char *s){		//string senden
	
  while(*s) uputc(*s++);				//sendet zeichenkette, bis ende.. '\0'    
  
}

#if (1)

// *******************************************************************
unsigned char ugetc(void){			//zeichen holen

  while (!(UCSRA & (1<<RXC))) {;}	// warten bis Zeichen verfuegbar
        
  return UDR;  		                // Zeichen aus UDR an Aufrufer zurueckgeben
}


// *******************************************************************
void ugets(char* Buffer, unsigned char MaxLen){	// zeichenkette holen
  unsigned char NextChar;
  unsigned char StringLen = 0;
 
  NextChar = ugetc();         		// Warte auf und empfange das nächste Zeichen  
                                
  while( NextChar != '\n' && StringLen < MaxLen - 1 ) {		//string ende oder puffer voll
    *Buffer++ = NextChar;
    StringLen++;
    NextChar = ugetc();
  }
   
  *Buffer = '\0';					//string abschluss
}
#endif


//*******************************************************************
void uinit (void){					//init usart Tx, 8n1 ,UDRE interupt enable

  UCSRC |= (3<<UCSZ0);    		// URSEL = 1 dann wird UCSRC benutzt sonst UBRRH ; UCSZ0=data register- 8bit; USBS stop bit 1 	
  //Baudrate (high und low byte)
  UBRRH = (unsigned char)(UBRR_VAL>>8);
  UBRRL = (unsigned char)UBRR_VAL;
  UCSRB |= (1<<TXEN)|(1<<RXEN);  	// UART TX,RX einschalten,	data register empty interrupt enable,
}

